/**
 * Datepickers.
 */

/**
 * Datepicker for "Set a deadline" in newproof.
 *
 * TODO: refactor this plugin not to use '.dp' selector
 */
var clearDatepickerEventAdded = false;
var currentDpInput = null;

/**
 * Main datepicket plugin
 */
$.fn.initDatePicker = function() {

		$(this).attr('readOnly', 'readOnly');

		$.waitForStaticFile(function() {

			$('.dp').each(function(idx, item, options) {
				var th = $(item);

				if (th.hasClass('no-dp-init')) {
					return;
				}

				var d = new Date();
				var mindate = th.attr('mindate');
				var dpDate = (new Date((parseInt(mindate) + d.getTimezoneOffset() * 60) * 1000));

				th.datepicker({
					minDate : mindate ? (new Date((parseInt(mindate) + (new Date()).getTimezoneOffset() * 60) * 1000)) : new Date(),
					showOn : 'both',
					buttonImage : assetsBaseUrl + '/images/dp_icon.png',
					buttonImageOnly : true,
					dateFormat : window.sDateFormat ? window.sDateFormat.replace(/\+/g, ' ') : 'yy-mm-dd',
					onClose : function() {
						var element = $(this);
						var elementVal = element.val();
						var deadlineTime = $('input[name=deadline_time]');
						var deadlineTimeVal = deadlineTime.val();
						if (deadlineTimeVal === '' || deadlineTimeVal === 'hh:mm') {
							deadlineTime.val('23:59');
						}

						var deadline = $('#deadline_time');
						var deadlineVal = deadline.val();
						if ((deadlineVal === '' || deadlineVal === 'hh:mm')
								&& (element.datepicker('getDate') !== null
										&& elementVal !== __('Click to select a date')
										&& elementVal !== __('No deadline'))) {

							var iServerTime = parseInt(element.attr('mindate'));//parseInt($("#server_time").val());
							var currentDate = new Date((iServerTime + (new Date()).getTimezoneOffset() * 60) * 1000);
							var h = currentDate.getHours();
							var m = currentDate.getMinutes();
							if (m < 30) {
								m = '30';
							} else {
								m = '00'; h = (h + 1) % 24;
							}
							deadline.val(h + ':' + m);
							deadline.updateCustomSelect();
						}
					},
					onSelect : function(dateText, inst) {
						var iServerTime = parseInt($(this).attr('mindate'));//parseInt($("#server_time").val());

						var timeDropdown =  $(inst.input).parent().parent().find('select'),
							cs = $(inst.input).parent().parent().find('div.custom_select'),
							selectedDate = $(this).datepicker('getDate'),
							iServerTimeInMil = (iServerTime + (new Date()).getTimezoneOffset() * 60)*1000;
							currentDate = new Date(iServerTimeInMil),
							timeOptions = cs.prev().find('option'),
							timeVal = timeDropdown.val(),
							minDate = 0,
							minTime = "00";

						// * Removing unnecessary (earlies than currrent time) hrs from custom field.
						if(selectedDate.getFullYear() == currentDate.getFullYear() &&
							selectedDate.getMonth() == currentDate.getMonth() &&
							selectedDate.getDate() == currentDate.getDate()) {

							minDate = currentDate.getHours();
							minTime = currentDate.getMinutes();

							if(minTime <= 30) {
								minTime = 30;
							}
							else {
								minTime = "00";
							}
						}

						timeDropdown.html(SBWConstants.getDealineHoursOptions(minDate + ':' + minTime));
						timeDropdown.val(timeVal);
						timeDropdown.updateCustomSelect();
						//---

						th.addClass('hasDate');
						$('input[name=deadline_time]').val('23:59');
						$(inst.input).removeClass('inactive');
						if(cs.length) {
							cs.prev().removeAttr('disabled');
							cs.removeClass('disabled');
							cs.prev().updateCustomSelect();
						}
						else {
							var time = th.parent().parent().find('select');
							time.removeAttr('disabled');
							time.updateCustomSelect();
						}
					},
					beforeShow: function(input, inst) {
						if (!$(item).attr('hideclearbtn')) {
							this.hasClearButtton = 1;
							setTimeout("$('#ui-datepicker-div').append('<div id=\"clear_datepicker\" class=\"page_link\">Clear</div>')", 100);
						}
						currentDpInput = th;
					},
					onChangeMonthYear : function(){
						if (!$(item).attr('hideclearbtn')) {
							setTimeout("if($('#clear_datepicker').length == 0){$('#ui-datepicker-div').append('<div id=\"clear_datepicker\" class=\"page_link\">Clear</div>')}", 100);
						}
					}
				});
			});
		});

		if (!clearDatepickerEventAdded) {
			$("#clear_datepicker").live('click', function(){

				if (currentDpInput) {
					currentDpInput
					.val('')
					.blur()
					.datepicker('hide')
					.val(__('Click to select a date'))
					.addClass('inactive');

					var select = currentDpInput.parent().parent().find('select.custom_select');
					if (select && select.length) {
						select.val('hh:mm');
						select.updateCustomSelect();
					}
					var cs = currentDpInput.parent().parent().find('div.custom_select');
					if (cs && cs.length) {
						$('select', cs).attr('disabled', 'disabled');
						cs.addClass('disabled');
					}

					// * US4276.
					if($('#details_page').length == 1) {

						// * Make sure that deadline in in edit mode.
						if($('#workflow_stages_section .deadline.deadlineEditMode').length > 0) {

							$('#details_page').click();
						}
					}
					// ---
				}
			});
			clearDatepickerEventAdded = true;
		}

}

/**
 * Datepicker for custom fields.
 */
var dtp;
var bufff = {}
$.fn.dateTimePicker = function(options){
	dtp = this;
	options = $.extend({}, {onSelect : function(){}, show : false}, options)
	bufff = options;
	$.waitForStaticFile(function(){
		dtp.each(function() {
			$(this)._dateTimePicker(bufff);
		})
	})
}

$.fn._dateTimePicker = function(options){
	var th = $(this),
		fieldName = th.attr('name'),
		bShowImage = false,
		bRestrictPast = false,
		bValue = false,
		oInput = $("input[name='"+fieldName.replace( 'picker', 'date' )+"']");

	if(th.attr('show_image')) {
		bShowImage = th.attr('show_image');
	}
	if(th.attr('restrict_past')) {
		bRestrictPast = th.attr('restrict_past');
	}
	if(oInput.val() != '') {
		bValue = true;
	}
	th.datepicker({
		dateFormat : window.sDateFormat ? window.sDateFormat.replace(/\+/g, ' ') : 'yy-mm-dd',
		changeMonth	: true,
		changeYear	: true,
		showOn : bShowImage?'both':'focus',
		buttonImage : assetsBaseUrl + '/images/dp_icon.png',
		buttonImageOnly : true,
		altField 	: "input[name='"+fieldName.replace( 'picker', 'date' )+"']",
		altFormat 	:  'yy-mm-dd',
		minDate		: bRestrictPast ? new Date() : null,
		onSelect 	: function(dataText, inst){
			if ((timeSelector && timeSelector.length == 1)&&(timeSelector.val() == 'hh:mm')){
				timeSelector.val('23:59');
			} else if ((timeSelector && timeSelector.length == 1)&&(timeSelector.val() != '')){
				var parts = timeSelector.val().split(':')
				if (parts.length != 2){
					timeSelector.val('23:59');
				}
			}
			$(inst.input).removeClass('inactive');
			var cs = $(inst.input).parent().parent().find('div.date_picker_custom_time');

			if (cs && cs.length) {
				cs.find('select').removeAttr('disabled');
				cs.find('select').updateCustomSelect();
			}

			options.onSelect();
		},
		beforeShow 	: function(input, inst){
			$(this).parents('div.custom_field_container').removeClass('has_error');
			cfErrorsHandle();
		}
	});

	// * Makes component "visible" (clickable).
	if(bValue) {
		var cs = oInput.parent().parent().find('div.date_picker_custom_time');
		cs.find('select').removeAttr('disabled');
		cs.find('select').updateCustomSelect();
	}
	$("input[name='"+fieldName.replace( 'picker', 'date' )+"']").datepicker({
		dateFormat : 'yy-mm-dd'
	})
	if ($("input[name='"+fieldName.replace( 'picker', 'date' )+"']") && $("input[name='"+fieldName.replace( 'picker', 'date' )+"']").val() && $("input[name='"+fieldName.replace( 'picker', 'date' )+"']").val().length > 0){
		th.datepicker('setDate', $("input[name='"+fieldName.replace( 'picker', 'date' )+"']").datepicker('getDate'))
	} else {
		if(phrases && phrases['Click to select a date']) {
			th.val(phrases['Click to select a date'])
		}
	}
	var timeSelector = $("input[name='"+fieldName.replace( '[picker]', '[time]' )+"']") // $("input[name='"+fieldName.replace( 'picker', '' )+"time']")

	if (timeSelector.length == 1){
		if (timeSelector.val() == ''){
			timeSelector.val('hh:mm')
		}
		timeSelector.focus(function(){
			if ($(this).val() == 'hh:mm'){
				$(this).val('')
			}
		})
		timeSelector.blur(function(){
			if ($(this).val() == ''){
				$(this).val('hh:mm')
			}
		})
	}
	$(this).blur(function(){
		if (($(this).val() == '') || ($(this).val() == phrases['Click to select a date'])){
			$("input[name='"+fieldName.replace( 'picker', 'date' )+"']").val(phrases['Click to select a date']);
		}
	});

	if(options.show) {
		th.datepicker('show');
	}
}

/**
 * Overwrite jquery.datepicked method to check offeset.
 * @see WA-4745
 * @author pcichosz
 */
jQuery.extend(jQuery.datepicker,{
	_checkOffset: function(inst, offset, isFixed){

		var dpOffsetHeight = offset.top + inst.dpDiv.outerHeight(),
			windowOffsetHeight = $(window).scrollTop() + $(window).height(),
			inputHeight = inst.input.outerHeight(),
			addtionalOffset = inst.id.search('dp') == -1 ? 22 : 0; // * Clear button.

		offset.top = offset.top;
		offset.left = offset.left;

		dpOffsetHeight += addtionalOffset;

		if(dpOffsetHeight > windowOffsetHeight) {
			offset.top = offset.top - inputHeight - inst.dpDiv.outerHeight() - addtionalOffset;
		}

		return offset;
	}});